Loading...
Searching...
No Matches
juce::MenuBarModel Class Referenceabstract

## Detailed Description

A class for controlling MenuBar components.

This class is used to tell a MenuBar what menus to show, and to respond to a menu being selected.

See also
  MenuBarModel::Listener, MenuBarComponent, PopupMenu

The documentation for this class was generated from the following file:

- juce_gui_basics/menus/juce_MenuBarModel.h

Inheritance diagram for juce::MenuBarModel:

## Classes

class | Listener
| A class to receive callbacks when a MenuBarModel changes. More...

## Public Member Functions

| MenuBarModel () noexcept
| ~MenuBarModel () override
| Destructor.
void | menuItemsChanged ()
| Call this when some of your menu items have changed.
void | setApplicationCommandManagerToWatch (ApplicationCommandManager *manager)
| Tells the menu bar to listen to the specified command manager, and to update itself when the commands change.
void | addListener (Listener *listenerToAdd)
| Registers a listener for callbacks when the menu items in this model change.
void | removeListener (Listener *listenerToRemove)
| Removes a listener.
virtual StringArray | getMenuBarNames ()=0
| This method must return a list of the names of the menus.
virtual PopupMenu | getMenuForIndex (int topLevelMenuIndex, const String &menuName)=0
| This should return the popup menu to display for a given top-level menu.
virtual void | menuItemSelected (int menuItemID, int topLevelMenuIndex)=0
| This is called when a menu item has been clicked on.
virtual void | menuBarActivated (bool isActive)
| This is called when the user starts/stops navigating the menu bar.
void | applicationCommandInvoked (const ApplicationCommandTarget::InvocationInfo &) override
| Called when an app command is about to be invoked.
void | applicationCommandListChanged () override
| Called when commands are registered or deregistered from the command manager, or when commands are made active or inactive.
void | handleAsyncUpdate () override
| Called back to do whatever your class needs to do.
void | handleMenuBarActivate (bool isActive)

## Static Public Member Functions

static void | setMacMainMenu (MenuBarModel *newMenuBarModel, const PopupMenu *extraAppleMenuItems=nullptr, const String &recentItemsMenuName=String())
| OSX ONLY - Sets the model that is currently being shown as the main menu bar at the top of the screen on the Mac.
static MenuBarModel * | getMacMainMenu ()
| OSX ONLY - Returns the menu model that is currently being shown as the main menu bar.
static const PopupMenu * | getMacExtraAppleItemsMenu ()
| OSX ONLY - Returns the menu that was last passed as the extraAppleMenuItems argument to setMacMainMenu(), or nullptr if none was specified.

## Constructors and Destructors

## MenuBarModel()

juce::MenuBarModel::MenuBarModel | ( |  | ) |

noexcept

Referenced by getMacMainMenu(), handleMenuBarActivate(), juce::MenuBarModel::Listener::menuBarActivated(), juce::MenuBarModel::Listener::menuBarItemsChanged(), juce::MenuBarModel::Listener::menuCommandInvoked(), setMacMainMenu(), and ~MenuBarModel().

## ~MenuBarModel()

juce::MenuBarModel::~MenuBarModel | ( |  | ) |

override

Destructor.

References MenuBarModel().

## Member Functions

## menuItemsChanged()

void juce::MenuBarModel::menuItemsChanged | ( |  | ) |

Call this when some of your menu items have changed.

This method will cause a callback to any MenuBarListener objects that are registered with this model.

If this model is displaying items from an ApplicationCommandManager, you can use the setApplicationCommandManagerToWatch() method to cause change messages to be sent automatically when the ApplicationCommandManager is changed.

See also
  addListener, removeListener, MenuBarListener

References menuItemsChanged().

Referenced by menuItemsChanged().

## setApplicationCommandManagerToWatch()

void juce::MenuBarModel::setApplicationCommandManagerToWatch | ( | ApplicationCommandManager * | manager | ) |

Tells the menu bar to listen to the specified command manager, and to update itself when the commands change.

This will also allow it to flash a menu name when a command from that menu is invoked using a keystroke.

References setApplicationCommandManagerToWatch().

Referenced by setApplicationCommandManagerToWatch().

## addListener()

void juce::MenuBarModel::addListener | ( | Listener * | listenerToAdd | ) |

Registers a listener for callbacks when the menu items in this model change.

The listener object will get callbacks when this object's menuItemsChanged() method is called.

See also
  removeListener

## removeListener()

void juce::MenuBarModel::removeListener | ( | Listener * | listenerToRemove | ) |

Removes a listener.

See also
  addListener

## getMenuBarNames()

virtual StringArray juce::MenuBarModel::getMenuBarNames | ( |  | ) |

pure virtual

This method must return a list of the names of the menus.

## getMenuForIndex()

virtual PopupMenu juce::MenuBarModel::getMenuForIndex | ( | int | topLevelMenuIndex,
|  | const String & | menuName )

pure virtual

This should return the popup menu to display for a given top-level menu.

Parameters

  topLevelMenuIndex | the index of the top-level menu to show
  menuName | the name of the top-level menu item to show

## menuItemSelected()

virtual void juce::MenuBarModel::menuItemSelected | ( | int | menuItemID,
|  | int | topLevelMenuIndex )

pure virtual

This is called when a menu item has been clicked on.

Parameters

  menuItemID | the item ID of the PopupMenu item that was selected
  topLevelMenuIndex | the index of the top-level menu from which the item was chosen (just in case you've used duplicate ID numbers on more than one of the popup menus)

## menuBarActivated()

virtual void juce::MenuBarModel::menuBarActivated | ( | bool | isActive | ) |

virtual

This is called when the user starts/stops navigating the menu bar.

Parameters

  isActive | true when the user starts navigating the menu bar

## setMacMainMenu()

void juce::MenuBarModel::setMacMainMenu | ( | MenuBarModel * | newMenuBarModel,
|  | const PopupMenu * | extraAppleMenuItems = nullptr,
|  | const String & | recentItemsMenuName = String() )

static

OSX ONLY - Sets the model that is currently being shown as the main menu bar at the top of the screen on the Mac.

You can pass nullptr to stop the current model being displayed. Be careful not to delete a model while it is being used.

An optional extra menu can be specified, containing items to add to the top of the apple menu. (Confusingly, the 'apple' menu isn't the one with a picture of an apple, it's the one next to it, with your application's name at the top and the services menu etc on it). When one of these items is selected, the menu bar model will be used to invoke it, and in the menuItemSelected() callback the topLevelMenuIndex parameter will be -1. If you pass in an extraAppleMenuItems object then newMenuBarModel must be non-null.

If the recentItemsMenuName parameter is non-empty, then any sub-menus with this name will be replaced by OSX's special recent-files menu.

References MenuBarModel().

## getMacMainMenu()

MenuBarModel * juce::MenuBarModel::getMacMainMenu | ( |  | ) |

static

OSX ONLY - Returns the menu model that is currently being shown as the main menu bar.

References MenuBarModel().

## getMacExtraAppleItemsMenu()

const PopupMenu * juce::MenuBarModel::getMacExtraAppleItemsMenu | ( |  | ) |

static

OSX ONLY - Returns the menu that was last passed as the extraAppleMenuItems argument to setMacMainMenu(), or nullptr if none was specified.

## applicationCommandInvoked()

void juce::MenuBarModel::applicationCommandInvoked | ( | const ApplicationCommandTarget::InvocationInfo & |  | ) |

override virtual

Called when an app command is about to be invoked.

Implements juce::ApplicationCommandManagerListener.

## applicationCommandListChanged()

void juce::MenuBarModel::applicationCommandListChanged | ( |  | ) |

override virtual

Called when commands are registered or deregistered from the command manager, or when commands are made active or inactive.

Note that if you're using this to watch for changes to whether a command is disabled, you'll need to make sure that ApplicationCommandManager::commandStatusChanged() is called whenever the status of your command might have changed.

Implements juce::ApplicationCommandManagerListener.

## handleAsyncUpdate()

void juce::MenuBarModel::handleAsyncUpdate | ( |  | ) |

override virtual

Called back to do whatever your class needs to do.

This method is called by the message thread at the next convenient time after the triggerAsyncUpdate() method has been called.

Implements juce::AsyncUpdater.

## handleMenuBarActivate()

void juce::MenuBarModel::handleMenuBarActivate | ( | bool | isActive | ) |

References MenuBarModel().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited